SystemOrganization addCategory: #STTutTodoApp!
SystemOrganization addCategory: #'STTutTodoApp-Tests'!

WAComponent subclass: #StListComponent
	instanceVariableNames: 'items filterBlock sortBlock renderItemBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:31'!
filterBlock

	^ filterBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
filterBlock: anObject

	filterBlock := anObject.! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
items

	^ items! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
items: anObject

	items := anObject.! !

!StListComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:28'!
renderContentOn: html

	html table: [(self sortBlock
		value: (self filterBlock value: self items))
		do: [:item | html tableRow: [self renderItemBlock
							value: item
							value: html]]].! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
renderItemBlock

	^ renderItemBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
renderItemBlock: anObject

	renderItemBlock := anObject.! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
sortBlock

	^ sortBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
sortBlock: anObject

	sortBlock := anObject.! !

WAComponent subclass: #StLoggedInComponent
	instanceVariableNames: 'menuComponent listComponent taskEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoggedInComponent class methodsFor: 'test data' stamp: 'dt 5/13/2008 15:37'!
testTasks

	^ OrderedCollection
		with: (StTask new
			deadline: Date yesterday;
			completed: false;
			taskName: 'Missed task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: false;
			taskName: 'Pending task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: true;
			taskName: 'Already completed task')! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:19'!
children

	^ Array with: self menuComponent with: self listComponent! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 14:56'!
createNewTask

	(self lightbox: self taskEditor newTask) ifFalse: [^ self].
	self session database
		addTask: self taskEditor task
		toUser: self session user.! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 14:57'!
editTask: aTask
	
	self taskEditor task: aTask copy.
	(self lightbox: self taskEditor) ifFalse: [^ self].
	aTask copyFrom: self taskEditor task.
	self session database save: aTask.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 5/12/2008 13:17'!
initialize

	super initialize.
	self
		initializeMenuComponent;
		initializeListComponent;
		addDecoration: StCopyrightDecoration new.		! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 14:22'!
initializeListComponent

	self listComponent: StListComponent new.
	self listComponent
		sortBlock: [:items |
			items sortBy: [:a :b | a deadline < b deadline]];
		renderItemBlock: [:task :html |
			self renderTask: task asRowOn: html];
		items: self session user tasks.
	self showPendingTasks.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 12:32'!
initializeMenuComponent

	self menuComponent:(StMenuComponent new
		addEntry: 'All' withAction: [self showAllTasks];
		addEntry: 'Completed' withAction: [self showCompletedTasks];
		addEntry: 'Pending' withAction: [self showPendingTasks];
		addEntry: 'Missed' withAction: [self showMissedTasks];
		addEntry: 'New Task' withAction: [self createNewTask];
		addEntry: 'Logout' withAction: [self session logout. self answer: true];
		yourself).! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
listComponent

	^ listComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
listComponent: anObject

	listComponent := anObject.! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
menuComponent

	^ menuComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
menuComponent: anObject

	menuComponent := anObject.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'LT 4/17/2011 00:06'!
renderCheckboxWith: aTask on: html

	| updater |
	updater := html prototype updater
		id: 'list';
		callback: [:renderer |
			aTask completed: aTask completed not.
			renderer render: self listComponent];
		yourself.
	html checkbox
		onClick: updater;
		value: aTask completed.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 11:26'!
renderContentOn: html

	html div
		class: 'generic';
		with:[
			html heading: 'ToDo-List of ', self session user userName.
			html div
			class: 'menu';
			with: self menuComponent.
			html div
			class: 'list';
			id: 'list';
			with: self listComponent].! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'LT 4/17/2011 00:07'!
renderInPlaceEditorWith: aTask on: html

	| editor |
	editor := html scriptaculous inPlaceEditor
		cancelControl: false;
		triggerInPlaceEditor: [:value | aTask taskName: value];
		callback: [:renderer | renderer render: aTask taskName];
		yourself.
	html div
		script: editor;
		with: aTask taskName.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'dt 5/6/2009 18:19'!
renderTask: aTask asRowOn: html

	html
		tableData: [self renderCheckboxWith: aTask on: html];
		tableData: aTask deadline asString;
		tableData: [self renderInPlaceEditorWith: aTask on: html];
		tableData: aTask taskDescription;
		tableData: [html anchor
					callback: [self editTask: aTask];
					with: 'edit'].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showAllTasks

	self listComponent
		filterBlock: [:items | items].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showCompletedTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item completed]].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:32'!
showMissedTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item isMissed]].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showPendingTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item isPending]].! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:06'!
taskEditor
    
	^ taskEditor ifNil: [taskEditor := StTaskEditor new]! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
taskEditor: anObject

	taskEditor := anObject.! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 5/13/2008 15:37'!
testTasks

	^ self class testTasks ! !

WAComponent subclass: #StLoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:51'!
applicationName

	^ StToDoLibrary applicationName ! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:34'!
email

	^ email! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
email: anObject

	email := anObject.! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/10/2008 10:37'!
hashPassword: aString

	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].
	! !

!StLoginComponent methodsFor: 'initialize-release' stamp: 'micper 5/12/2008 13:53'!
initialize
	
	super initialize.
	self addDecoration: StCopyrightDecoration new.! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:31'!
loginFailed

	self messageComponent errorMessage: 'Login failed.'.! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:56'!
messageComponent

	^ messageComponent ifNil: [messageComponent := StMessageComponent new]! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
messageComponent: anObject

	messageComponent := anObject.! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
password

	^ password! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
password: anObject

	password := anObject.! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:32'!
registerUser
	
	self answer: #registerUser.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'dt 4/11/2008 19:57'!
renderContentOn: html

	html div
	class: 'generic';
	with: [
		html
			heading: self applicationName;
			render: self messageComponent;
			text: 'Please login with e-mail and password:';
			form: [
				self
					renderTextInputOn: html;
					renderPasswordInputOn: html;
					renderLoginButtonOn: html;
					renderSignUpAnchorOn: html]].! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:15'!
renderLoginButtonOn: html

	html submitButton
		callback: [self validateLogin];
		text: 'Login'.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:15'!
renderPasswordInputOn: html

	html passwordInput
		callback: [:value | self password: (self hashPassword: value)];
		value: ''.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:16'!
renderSignUpAnchorOn: html

	html paragraph with: [html anchor
		callback: [self registerUser];
		with: [html text: 'Sign up for the ', self applicationName]].! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:14'!
renderTextInputOn: html

	html textInput
		on: #email of: self;
		value: ''.
	html space.! !

!StLoginComponent methodsFor: 'actions' stamp: 'dt 4/11/2008 19:40'!
validateLogin

	| user |
	user := self session findUserByEmail: self email.
	(user notNil and: [user password = self password])
		ifTrue: [self answer: user]
		ifFalse: [self loginFailed].! !

WAComponent subclass: #StMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMenuComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:21'!
addEntry: aString withAction: aBlock
	
	^ self entries add: aString -> aBlock! !

!StMenuComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:36'!
entries

	^ entries! !

!StMenuComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
entries: anObject

	entries := anObject.! !

!StMenuComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:23'!
initialize

	super initialize.
	self entries: OrderedCollection new.! !

!StMenuComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:22'!
renderContentOn: html

	self entries
		do: [:entry |
			html anchor
				callback: entry value;
				with: entry key]
		separatedBy: [html space].! !

WAComponent subclass: #StMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMessageComponent commentStamp: 'ab 7/17/2007 14:36' prior: 0!
I can display information messages like errors or confirmations!

!StMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:17'!
errorMessage: aString

	self
		messageString: aString;
		messageType: 'error';
		wasShown: false.! !

!StMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:18'!
infoMessage: aString

	self
		messageString: aString;
		messageType: 'info';
		wasShown: false.! !

!StMessageComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 13:15'!
initialize

	super initialize.
	self wasShown: true.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageString

	^ messageString! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageString: anObject

	messageString := anObject.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageType

	^ messageType! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageType: anObject

	messageType := anObject.! !

!StMessageComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 13:18'!
renderContentOn: html

	self wasShown ifTrue: [^ self].
	html div
		class: self messageType, 'Message';
		with: self messageString.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
wasShown

	^ wasShown! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
wasShown: anObject

	wasShown := anObject.! !

WAComponent subclass: #StRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRegisterComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:01'!
hashPassword: aString
	
	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].! !

!StRegisterComponent methodsFor: 'initialize-release' stamp: 'micper 5/12/2008 13:18'!
initialize

	super initialize.
	self 
		user: StUser new;
		addDecoration: StCopyrightDecoration new.
	! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:56'!
messageComponent

	^ messageComponent ifNil: [messageComponent := StMessageComponent new]! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:38'!
messageComponent: anObject

	messageComponent := anObject.! !

!StRegisterComponent methodsFor: 'actions' stamp: 'dt 4/13/2008 12:44'!
registerUser
    
	self user userName isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a username!!'].
	self user email isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please enter your e-mail address!!'].
	(self session findUserByEmail: self user email)
		ifNotNil: [^ self messageComponent errorMessage: 'The e-mail address is already registered!!'].
	self user password = 0
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a password!!'].
	self user password = self repeatedPassword
		ifFalse: [^ self messageComponent infoMessage: 'Your repeated password does not match!!'].
	self session database addUser: self user.
	self answer: self user.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:58'!
renderCancelButtonOn: html
	
	html submitButton
		callback: [self answer: nil];
		text: 'Cancel'.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:54'!
renderContentOn: html

	html div
		class: 'generic';
		with: [
			html
				heading: 'Register';
				render: self messageComponent;
				form: [
					html table: [
						self
							renderUsernameTextInputOn: html;
							renderEmailTextInputOn: html;
							renderPasswordTextInputOn: html;
							renderRepeatedPasswordTextInputOn: html.
						html tableRow: [
							html
								tableData;
								tableData: [
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html]]]]].
	! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'dt 4/13/2008 12:45'!
renderEmailTextInputOn: html

	html tableRow: [
		html
			tableData: 'E-mail';
			tableData: [
				html textInput
					callback: [:value | self user email: value];
					value: self user email]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'dt 4/11/2008 19:48'!
renderPasswordTextInputOn: html
    
	html tableRow: [
		html
			tableData: 'Password';
			tableData: [
				html passwordInput
					callback: [:value | self user password: (self hashPassword: value)]]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'dt 4/11/2008 19:48'!
renderRepeatedPasswordTextInputOn: html
  
	html tableRow: [
		html
			tableData: 'Repeat password';
			tableData: [
				html passwordInput
					callback: [:value | self repeatedPassword: (self hashPassword: value)]]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:57'!
renderSubmitButtonOn: html

	html submitButton
		callback: [self registerUser];
		text: 'Register'.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:59'!
renderUsernameTextInputOn: html

	html tableRow: [
		html
		tableData: 'Username';
		tableData: [
			html textInput
				callback: [:value | self user userName: value];
				value: self user userName]].! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:38'!
repeatedPassword

	^ repeatedPassword! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
repeatedPassword: anObject

	repeatedPassword := anObject.! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user

	^ user! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user: anObject

	user := anObject.! !

WAComponent subclass: #StTaskEditor
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTaskEditor methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:53'!
initialize

	super initialize.
	self task: StTask new.! !

!StTaskEditor methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:14'!
newTask

	self task: StTask new.! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:58'!
renderButtonsOn: html

	html
		tableData;
		tableData: [
			html submitButton
				callback: [self answer: true];
				value: 'Save'.
			html submitButton
				callback: [self answer: false];
				value: 'Cancel'].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:57'!
renderCompletedSelectionOn: html

	html
		tableData: [html text: 'Completed: '];
		tableData: [
			html select
				add: true;
				add: false;
				on: #completed of: self task;
				labels: [:value |
					value
						ifTrue: ['yes']
						ifFalse: ['no']]].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:55'!
renderContentOn: html

	html div
		class: 'generic lightbox';
		with: [
			html heading: 'Editing task'.
			html form: [
				html table: [
					html
						tableRow: [self renderNameInputOn: html];
						tableRow: [self renderDescriptionInputOn: html];
						tableRow: [self renderDateInputOn: html];
						tableRow: [self renderCompletedSelectionOn: html];
						tableRow: [self renderButtonsOn: html]]]].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderDateInputOn: html

	html
		tableData: [html text: 'Deadline: '];
		tableData: [html dateInput on: #deadline of: self task].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderDescriptionInputOn: html

	html
		tableData: [html text: 'Description: '];
		tableData: [html textArea on: #taskDescription of: self task].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderNameInputOn: html

	html
		tableData: [html text: 'Name: '];
		tableData: [html textInput on: #taskName of: self task].! !

!StTaskEditor methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
task

	^ task! !

!StTaskEditor methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
task: anObject

	task := anObject.! !

WADecoration subclass: #StCopyrightDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StCopyrightDecoration methodsFor: 'rendering' stamp: 'LT 4/7/2011 09:21'!
renderContentOn: html

	self renderNextOn: html.
	html div
		class: 'copyright';
		with: [	html 
			html: '&#169;';
				text: ' Copyright ', 
					Date today year asString,
					' Software Architecture Group'].! !

WATask subclass: #StRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRootTask class methodsFor: 'testing' stamp: 'micper 4/9/2008 11:39'!
canBeRoot

	^ true! !

!StRootTask class methodsFor: 'testing' stamp: 'topa 4/11/2011 14:22'!
initialize

	(WAAdmin
		register: self
		asApplicationAt: 'todo')
		addLibrary: PTDevelopmentLibrary;
		addLibrary: SUDevelopmentLibrary;
		addLibrary: StToDoLibrary;
		preferenceAt: #sessionClass put: StSession.! !

!StRootTask methodsFor: 'processing' stamp: 'dt 4/11/2008 19:57'!
go

	| loginAnswer user |
	loginAnswer := self call: StLoginComponent new.
	loginAnswer = #registerUser
		ifTrue: [user := self call: StRegisterComponent new]
		ifFalse: [user := loginAnswer].
	user ifNotNil: [
		self session login: user.
		self call: StLoggedInComponent new].! !

Object subclass: #StDatabase
	instanceVariableNames: 'connectionFailed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:50'!
addTask: aTask toUser: aUser

	self subclassResponsibility.! !

!StDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:50'!
addUser: aUser

	self subclassResponsibility.! !

!StDatabase methodsFor: 'connection' stamp: 'topa 2/16/2011 13:15'!
connect

	^ true! !

!StDatabase methodsFor: 'accessing' stamp: 'topa 2/16/2011 13:15'!
connectionFailed

	^ false! !

!StDatabase methodsFor: 'accessing' stamp: 'tkow 5/8/2009 11:10'!
connectionFailed: aBoolean

	connectionFailed := aBoolean.! !

!StDatabase methodsFor: 'connection' stamp: 'topa 2/16/2011 13:15'!
disconnect

	^ true! !

!StDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:50'!
findUserByEmail: anEmail

	self subclassResponsibility.! !

!StDatabase methodsFor: 'initialize-release' stamp: 'LT 4/7/2011 22:49'!
initialize

	self connectionFailed: false! !

!StDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:48'!
updateTask: aTask

	self subclassResponsibility.! !

StDatabase subclass: #StImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Users WriteMutex'
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:10'!
users
	
	^ Users ifNil: [Users := OrderedCollection new]! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:31'!
users: anObject

	Users := anObject.! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:12'!
writeMutex
	
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:31'!
writeMutex: anObject

	WriteMutex := anObject.! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:17'!
addTask: aTask toUser: aUser

	aUser addTask: aTask.
	self saveImage.
	^ aTask! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:16'!
addUser: aUser

	self class users add: aUser.
	self saveImage.
	^ aUser! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:18'!
disconnect! !

!StImageDatabase methodsFor: 'accessing' stamp: 'LT 4/7/2011 22:09'!
findUserByEmail: anEmail

	^ self class users
		detect: [:each | each email = anEmail]
		ifNone: [nil]! !

!StImageDatabase methodsFor: 'actions' stamp: 'topa 2/16/2011 13:18'!
save: anObject
	
	self saveImage.! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:14'!
saveImage

	self class writeMutex critical: [self saveImageWithoutMonitor].! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:11'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession.! !

!StImageDatabase methodsFor: 'actions' stamp: 'LT 4/7/2011 22:27'!
updateTask: aTask
	
	self saveImage.! !

StImageDatabase subclass: #StImageTestdatabase
	instanceVariableNames: ''
	classVariableNames: 'TestUsers'
	poolDictionaries: ''
	category: 'STTutTodoApp-Tests'!

!StImageTestdatabase class methodsFor: 'actions' stamp: 'dt 4/22/2008 21:19'!
reset

	self users: OrderedCollection new.! !

!StImageTestdatabase class methodsFor: 'accessing' stamp: 'dt 4/22/2008 21:18'!
users

	^ TestUsers ifNil: [TestUsers := OrderedCollection new]! !

!StImageTestdatabase class methodsFor: 'accessing' stamp: 'dt 4/22/2008 20:34'!
users: anObject

	TestUsers := anObject.! !

!StImageTestdatabase methodsFor: 'actions' stamp: 'dt 4/22/2008 20:33'!
saveImage! !

StDatabase subclass: #StRelationalDatabase
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

StRelationalDatabase class
	instanceVariableNames: 'WriteMutex'!

StRelationalDatabase class
	instanceVariableNames: 'WriteMutex'!

!StRelationalDatabase class methodsFor: 'configuration' stamp: 'LT 4/7/2011 23:20'!
connectionArguments
 
	^ PGConnectionArgs
		hostname: self hostname
		portno: self port
  		databaseName: self databaseName
  		userName: self userName
  		password: self password.! !

!StRelationalDatabase class methodsFor: 'configuration' stamp: 'LT 4/7/2011 23:21'!
databaseName

	^ 'squeak'! !

!StRelationalDatabase class methodsFor: 'configuration' stamp: 'LT 4/7/2011 23:20'!
hostname

	^ 'localhost'! !

!StRelationalDatabase class methodsFor: 'configuration' stamp: 'LT 4/7/2011 23:21'!
password

	^ 'squeak'! !

!StRelationalDatabase class methodsFor: 'configuration' stamp: 'LT 4/7/2011 23:21'!
port

	^ 5432! !

!StRelationalDatabase class methodsFor: 'setup' stamp: 'LT 4/7/2011 23:27'!
setup

	self new
		connect;
		createTables;
		disconnect.! !

!StRelationalDatabase class methodsFor: 'configuration' stamp: 'LT 4/7/2011 23:21'!
userName

	^ 'squeak'! !

!StRelationalDatabase class methodsFor: 'accessing' stamp: 'LT 4/8/2011 00:19'!
writeMutex
		
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!StRelationalDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 23:33'!
addTask: aTask toUser: aUser
 
	self class writeMutex critical: [
		self connection execute:
			'insert into sttask
				(taskName, taskDescription, completed, deadline, stuser)
			values
				(''', aTask taskName, ''',
				''', aTask taskDescription, ''',
				''', aTask completed, ''',
				''', aTask deadline, ''',
				''', aUser email, ''')'.
		aTask id: self lastInsertedTaskId].! !

!StRelationalDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 23:33'!
addUser: aUser

	self connection execute:
		'insert into stuser (userName, password, email)
		values
			(''', aUser userName,''',
			''', aUser password,''',
			''', aUser email,''');'. ! !

!StRelationalDatabase methodsFor: 'connection' stamp: 'LT 4/7/2011 23:23'!
connect

	self connection: (PGConnection new
		connectionArgs: self class connectionArguments;
		startup;
		yourself).! !

!StRelationalDatabase methodsFor: 'accessing' stamp: 'LT 4/7/2011 23:19'!
connection
	"Answer the value of connection"

	^ connection! !

!StRelationalDatabase methodsFor: 'accessing' stamp: 'LT 4/7/2011 23:19'!
connection: anObject
	"Set the value of connection"

	connection := anObject! !

!StRelationalDatabase methodsFor: 'accessing' stamp: 'LT 4/7/2011 23:23'!
connectionFailed

	^ self connection isNil or: [self connection isConnected not]! !

!StRelationalDatabase methodsFor: 'table-creation' stamp: 'LT 4/7/2011 23:27'!
createTables

	self
		createUserTable;
		createTaskTable.! !

!StRelationalDatabase methodsFor: 'table-creation' stamp: 'LT 4/7/2011 23:26'!
createTaskTable

	self connection execute:
		'CREATE TABLE sttask (
		id serial PRIMARY KEY,
		taskName varchar(50) NOT NULL,
		taskDescription varchar(200),
		completed boolean NOT NULL,
		deadline date NOT NULL,
		stuser varchar(50) references stuser(email) NOT NULL);'.! !

!StRelationalDatabase methodsFor: 'table-creation' stamp: 'LT 4/7/2011 23:26'!
createUserTable
 
	self connection execute:
		'CREATE TABLE stuser (
		userName varchar(50) NOT NULL,
		password varchar(50) NOT NULL,
		email varchar(50) NOT NULL PRIMARY KEY);'.! !

!StRelationalDatabase methodsFor: 'connection' stamp: 'LT 4/7/2011 23:24'!
disconnect
 
	(self connection notNil and: [self connection isConnected])
		ifTrue: [self connection terminate].! !

!StRelationalDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 23:38'!
findUserByEmail: aString

	| user |
	user := self retrieveUserByEmail: aString.
	user ifNotNil: [ | tasks |
		tasks := self retrieveTasksByUsersEmail: aString.
		user tasks: tasks].
	^ user! !

!StRelationalDatabase methodsFor: 'initialize-release' stamp: 'LT 4/7/2011 23:24'!
initialize
 
	super initialize.
	self connect.! !

!StRelationalDatabase methodsFor: 'accessing' stamp: 'LT 4/7/2011 23:31'!
lastInsertedTaskId
 
	| result |
	result := self connection execute:
		'select currval(pg_get_serial_sequence(''sttask', '''id''));'.
	^ result errorResponse
		ifNil: [result resultSets first dataRows first at: 1]! !

!StRelationalDatabase methodsFor: 'accessing' stamp: 'LT 4/7/2011 23:37'!
retrieveTasksByUsersEmail: aString
 
	| resultSet |
	resultSet := self connection execute:
		'select * from sttask where stuser=''', aString, ''';'.
	^ resultSet dataRows collect: 
		[ :each | StTask newFromDataRow: each].! !

!StRelationalDatabase methodsFor: 'accessing' stamp: 'LT 4/7/2011 23:37'!
retrieveUserByEmail: aString
 
	| resultSet |
	resultSet := self connection execute:
		'select * from stuser where email=''', aString, ''';'.
	^ StUser newFromResultSet: resultSet
! !

!StRelationalDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 23:35'!
updateTask: aTask
 
	self connection execute:
		'update sttask
			set
    			taskName = ''', aTask taskName, ''',
    			taskDescription = ''', aTask taskDescription, ''',
    			completed = ''', aTask completed, ''',
    			deadline = ''', aTask deadline, '''
   		where
    		id = ''', aTask id,''''.! !

StDatabase subclass: #StSandstoneDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StSandstoneDatabase class methodsFor: 'class initialization' stamp: 'LT 4/7/2011 23:13'!
initialize

	| class |
	class := Smalltalk classNamed: #SDActiveRecord.
	class ifNotNil: [class warmUpAllClasses].! !

!StSandstoneDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:45'!
addTask: aTask toUser: aUser

	aUser addTask: aTask. 
	aUser save. 
	^ aTask! !

!StSandstoneDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:44'!
addUser: aUser

	aUser save. 
	^ aUser! !

!StSandstoneDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:46'!
findUserByEmail: aString 

	^ StUser find: [ :each | each email = aString]! !

!StSandstoneDatabase methodsFor: 'public' stamp: 'LT 4/7/2011 22:46'!
updateTask: aTask
 
	| user | 
	user := StUser find: [ :each | each tasks includes: aTask]. 
	user save.! !

Object subclass: #StTask
	instanceVariableNames: 'completed deadline taskDescription id taskName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTask class methodsFor: 'instance creation' stamp: 'LT 4/7/2011 23:45'!
newFromDataRow: aPGDataRow
 
	^ StTask new
		id: (aPGDataRow atName: #id);
		taskName: (aPGDataRow atName: #taskname);
		taskDescription: (aPGDataRow atName: #taskdescription);
		completed: (aPGDataRow atName: #completed);
		deadline: (aPGDataRow atName: #deadline); 
		yourself! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
completed

	^ completed! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
completed: anObject

	completed := anObject.! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
deadline

	^ deadline! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
deadline: anObject

	deadline := anObject.! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
id

	^ id! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
id: anObject

	id := anObject.! !

!StTask methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:13'!
initialize

	self
		deadline: Date tomorrow;
		completed: false.! !

!StTask methodsFor: 'comparing' stamp: 'micper 4/9/2008 10:12'!
isMissed

	^ self completed not and: [self deadline < Date today]! !

!StTask methodsFor: 'comparing' stamp: 'micper 4/9/2008 10:11'!
isPending

	^ self completed not and: [self deadline >= Date today]! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskDescription

	^ taskDescription! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskDescription: anObject

	taskDescription := anObject.! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskName

	^ taskName! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskName: anObject

	taskName := anObject.! !

Object subclass: #StUser
	instanceVariableNames: 'id userName email tasks password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StUser commentStamp: 'PO 9/6/2007 16:30' prior: 0!
I am the User of the Tutorial ToDo-Application

I own my categories in a SortedList
And my tasks in a Set!

!StUser class methodsFor: 'instance creation' stamp: 'LT 4/7/2011 23:44'!
newFromResultSet: aPGResultSet
 
	^ (aPGResultSet rows size = 1)
		ifTrue: [ | row |
			row := aPGResultSet dataRows first.
			StUser new
				userName: (row atName: #username);
				email: (row atName: #email);
				password: (row atName: #password) asNumber;
				yourself]
			ifFalse: [nil]! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:09'!
addTask: aTask
	
	^ self tasks add: aTask! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
email

	^ email! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
email: anObject

	email := anObject.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
id

	^ id! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
id: anObject

	id := anObject.! !

!StUser methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:08'!
initialize
	
	self tasks: OrderedCollection new.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
password

	^ password! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
password: anObject

	password := anObject.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
tasks

	^ tasks! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
tasks: anObject

	tasks := anObject.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
userName

	^ userName! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:43'!
userName: anObject

	userName := anObject.! !

WAFileLibrary subclass: #StToDoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StToDoLibrary class methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:50'!
applicationName

	^ 'ToDo Application'! !

!StToDoLibrary methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:53'!
selectorsToInclude

	^ #( todoCss )! !

!StToDoLibrary methodsFor: 'uploaded' stamp: 'micper 5/12/2008 13:25'!
todoCss

	^ '
body {
	font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
	
.generic {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-style: normal;
	font-weight: normal;
	font-size: 14px;
	color : #663300;
	padding: 20px;
	margin-top: 20px;
	margin-left: 20px;
	border: 1px solid #663300;
	width: 500px;
}

.lightbox {
	background-color:#FFFFFF;
}

.errorMessage {
	background-color: #ffb0b0;
	border: 1px solid #ee0000;
	padding: 5px;
	margin-bottom: 10px;
}

.infoMessage {
	background-color: #fbffcc;
	border: 1px solid #eda33a;
	padding: 5px;
	margin-bottom: 10px;
}

.copyright {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 10px;
	font-style: normal;
	font-weight: normal;
	color: #663300;
	text-align: left;
	margin-left: 20px;
}

a {
	color : #663300;
	text-decoration: underline;
}'! !

WASession subclass: #StSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
database

	^ database! !

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
database: anObject

	database := anObject.! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 14:28'!
findUserByEmail: anEmail

	^ self database findUserByEmail: anEmail! !

!StSession methodsFor: 'initializing' stamp: 'tkow 5/12/2009 14:43'!
initialize
	
	super initialize.
	self database: StImageDatabase new.! !

!StSession methodsFor: 'comparing' stamp: 'LT 4/17/2011 00:09'!
isLoggedIn

	^ self user notNil! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
login: aUser
	
	self user: aUser.! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
logout

	self user: nil.! !

!StSession methodsFor: 'request handling' stamp: 'micper 4/9/2008 14:29'!
responseForRequest: aRequest

	self database connectionFailed
		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!StSession methodsFor: 'private' stamp: 'micper 4/9/2008 14:21'!
unregistered

	self database disconnect.
	super unregistered.! !

!StSession methodsFor: 'updating' stamp: 'micper 4/9/2008 13:54'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: StToDoLibrary applicationName.! !

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user

	^ user! !

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user: anObject

	user := anObject.! !

StSession subclass: #StTestSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-Tests'!

!StTestSession methodsFor: 'initializing' stamp: 'dt 4/22/2008 20:34'!
initialize
	
	super initialize.
	self database: StImageTestdatabase new.! !
StRootTask initialize!
StSandstoneDatabase initialize!
